VERSION 5.00
Begin VB.UserControl EventHandler 
   BackStyle       =   0  'Transparent
   CanGetFocus     =   0   'False
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   495
   ClipControls    =   0   'False
   DrawMode        =   11  'Not Xor Pen
   FillStyle       =   0  'Solid
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   11.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   -1  'True
      Strikethrough   =   0   'False
   EndProperty
   FontTransparent =   0   'False
   HasDC           =   0   'False
   InvisibleAtRuntime=   -1  'True
   MaskColor       =   &H00000080&
   MaskPicture     =   "Events - Handling [Class].ctx":0000
   Picture         =   "Events - Handling [Class].ctx":0282
   ScaleHeight     =   480
   ScaleWidth      =   495
   ToolboxBitmap   =   "Events - Handling [Class].ctx":0504
   Windowless      =   -1  'True
End
Attribute VB_Name = "EventHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'==================================================================
'
' Sable Event Handler Control for Windows 
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================



' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' '
' * * * * * * * * * * * Caution * * * * * * * * * * * * '
' *                                                   * '
' *               Subclasssing/Hooking                * '
' *                                                   * '
' *  CHANGES MADE TO THE FUNCTIONS CONTAINED HEREIN   * '
' *  CAN RESULT IN A GPF, PAGE FAULT OR EVEN          * '
' *  WINDOWS CAN GET A STACK OVERFLOW!?               * '
' *  SO SAVE YOUR CHANGES, START WITH FULL COMPILE,   * '
' *  BEFORE RUNNING THIS CLASS IN THE VB IDE!         * '
' *  USING THE BREAK-, END -BUTTON OR END STATEMENT   * '
' *  COULD GPF VB (FORTUNATILY I PROGRAMMED A         * '
' *  SAFETY-NET, BUT IT'S NOT 100% SECURE)            * '
' *                                                   * '
' *  DOING STUPID THINGS ANYWAY WILL GPF THE VB IDE!  * '
' *                                                   * '
' * * * * * * * * * * * Caution * * * * * * * * * * * * '
' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' '

'======================================================
' Declarations

Private ME_OBJPTR As Long

Private Const ERR_BASE = 12500
Private Const ERR_INTERNAL_STR = "An Internal error occured in the EventHandler control." & vbCrLf & "Please contact me at diederik_vd_boor@hotmail.com to report the conditions under which the error occured."
Private Const ERR_NOWINDOW_STR = "The window handle doesn't belong to an existing window!"
Private Const ERR_HOOKED_STR = "The window is already hooked by an EventHandler control!"
Private Const ERR_NOTHOOKED_STR = "The window isn't hooked by an EventHandler control!"
Private Const ERR_GETWINPROCFAILED_STR = "EventHandler failed to read the winproc handle!"
Private Const ERR_SETWINPROCFAILED_STR = "EventHandler failed to assign a new winproc handle!"
Private Const ERR_SOURCE = "Subclassing.EventHandler"

Public Enum EventErrors
  evtErrInternal = ERR_BASE
  evtErrNoWindow = ERR_BASE + 1
  evtErrHooked = ERR_BASE + 2
  evtErrNotHooked = ERR_BASE + 3
  evtErrGetWinProcFailed = ERR_BASE + 4
  evtErrSetWinProcFailed = ERR_BASE + 5
End Enum

Public Enum EventResultMessage
  evtCallPrevWinProc = &H80000000 ' EventHandler-result: Call original winproc (&H80000000 is lowest long negative number)
  evtHandled = 0                  ' API callback-result: Everything OK.
  evtIgnored = 1                  ' API callback-result: Error; Ignored Event
End Enum

' Events
Public Event ReceivedMessage(ByVal hWnd As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef ReturnMessage As EventResultMessage)
Attribute ReceivedMessage.VB_Description = "This event will be raised when a window message is detected."
Attribute ReceivedMessage.VB_MemberFlags = "200"
Public Event ChangeWinProc(ByVal hWnd As Long, ByVal FromProc As Long, ByVal ToProc As Long)
Attribute ChangeWinProc.VB_Description = "Occured when a window proc has changed by this instance of the EventHandler control."
Public Event Hooked(ByVal hWnd As Long)
Attribute Hooked.VB_Description = "Occures when a window is subclassed, as a result of setting the Attached property of this EventHandler instance to True."
Public Event UnHooked(ByVal hWnd As Long)
Attribute UnHooked.VB_Description = "Occures when a window is not subclassed anymore by this EventHandler instance, as a result of setting the Attached property of this EventHandler instance to True."


'======================================================
' Interface for hooking

' Redirect events to our event handler class
Public Property Let Attached(ByVal hWnd As Long, ByVal NewValue As Boolean)
Attribute Attached.VB_Description = "Returns/sets the attached state of a window."
  Dim WinProp As Long
  
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".Attached", ERR_NOWINDOW_STR
  If NewValue = True Then
    If Not Me.Attached(hWnd) Then
      ' Store handles, Set new winproc
      If SetProp(hWnd, WIN_PROP_OLDPROC, Me.WinProc(hWnd)) = 0 Then Err.Raise evtErrInternal, ERR_SOURCE & ".Attached", ERR_INTERNAL_STR
      Me.WinProc(hWnd) = ProcToPtr(AddressOf EventHandler_WinProc)
      If SetProp(hWnd, WIN_PROP_CLSPTR, ME_OBJPTR) = 0 Then Err.Raise evtErrInternal, ERR_SOURCE & ".Attached", ERR_INTERNAL_STR
      RaiseEvent Hooked(hWnd)
    Else
      Err.Raise evtErrHooked, ERR_SOURCE & ".Attached", ERR_HOOKED_STR
    End If
  Else
    WinProp = Me.PrevWinProc(hWnd)
    If WinProp <> 0 Then
      Me.WinProc(hWnd) = WinProp
      Call RemoveProp(hWnd, WIN_PROP_OLDPROC)
      Call RemoveProp(hWnd, WIN_PROP_CLSPTR)
      RaiseEvent UnHooked(hWnd)
    End If
  End If
End Property

Public Property Get Attached(ByVal hWnd As Long) As Boolean
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".Attached", ERR_NOWINDOW_STR
  Attached = ((GetProp(hWnd, WIN_PROP_OLDPROC) <> 0) And (GetProp(hWnd, WIN_PROP_CLSPTR) <> 0))
End Property

Public Function CallWinProc(ByVal hWnd As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long) As EventResultMessage
Attribute CallWinProc.VB_Description = "Calls the current window event handler procedure."
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".CallWinProc", ERR_NOWINDOW_STR
  CallWinProc = SendMessage(hWnd, WindowMessage, wParam, lParam)
End Function

Public Function CallPrevWinProc(ByVal hWnd As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long) As EventResultMessage
Attribute CallPrevWinProc.VB_Description = "Calls the previouswindow event handler procedure."
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".CallPrevWinProc", ERR_NOWINDOW_STR
  CallPrevWinProc = CallWindowProc(Me.PrevWinProc(hWnd), hWnd, WindowMessage, wParam, lParam)
End Function

Public Function CallCustWinProc(ByVal WinProcAddress As Long, ByVal hWnd As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long) As EventResultMessage
Attribute CallCustWinProc.VB_Description = "Calls a custom window event handler procedure."
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".CallCustWinProc", ERR_NOWINDOW_STR
  CallCustWinProc = CallWindowProc(WinProcAddress, hWnd, WindowMessage, wParam, lParam)
End Function

Public Function CallDefaultWinProc(ByVal hWnd As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long) As EventResultMessage
Attribute CallDefaultWinProc.VB_Description = "Calls the default window event handler procedure."
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".CallDefaultWinProc", ERR_NOWINDOW_STR
  CallDefaultWinProc = DefWindowProc(hWnd, WindowMessage, wParam, lParam)
End Function

' Useful when you want to call the previous winprocs yourself
Public Property Get PrevWinProc(ByVal hWnd As Long) As Long
Attribute PrevWinProc.VB_Description = "Returns a handle to the previous window event handler procedure."
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".PrevProc", ERR_NOWINDOW_STR
  PrevWinProc = GetProp(hWnd, WIN_PROP_OLDPROC)
  If PrevWinProc = 0 Then Err.Raise evtErrGetWinProcFailed, ERR_SOURCE & ".PrevWinProc", ERR_GETWINPROCFAILED_STR
End Property


'======================================================
' Hooking Code.
' (Only programmers that are known with subclassing)
' (should call these methods/properties)

' First, we need to store the address of the existing (VB) Message Handler
' We must return control of the messages back to windows before the program exits
Public Property Get WinProc(ByVal hWnd As Long) As Long
Attribute WinProc.VB_Description = "Returns/sets the the handle of default window event handler procedure for a window."
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".WinProc", ERR_NOWINDOW_STR
  WinProc = GetWindowLong(hWnd, GWL_WNDPROC)
  If WinProc = 0 Then Err.Raise evtErrGetWinProcFailed, ERR_SOURCE & ".WinProc", ERR_GETWINPROCFAILED_STR
End Property

' Now we can tell windows to forward all messages to out own Message Handler
Public Property Let WinProc(ByVal hWnd As Long, ByVal NewProc As Long)
  If IsWindow(hWnd) = 0 Then Err.Raise evtErrNoWindow, ERR_SOURCE & ".WinProc", ERR_NOWINDOW_STR
  Dim OldProc As Long
  OldProc = SetWindowLong(hWnd, GWL_WNDPROC, NewProc)
  If OldProc = 0 Then Err.Raise evtErrSetWinProcFailed, ERR_SOURCE & ".WinProc", ERR_SETWINPROCFAILED_STR
  RaiseEvent ChangeWinProc(hWnd, OldProc, NewProc)
End Property

' Raise the ReceivedMessage_Event from external modules
' (used by the EventHandler_Callback module)
Friend Function RaiseEventRM(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As EventResultMessage
  Static PrevMessage As Long
  Static PrevhWnd As Long
  Static PrevlParam As Long
  Static PrevwParam As Long
  Dim ReturnMessage As EventResultMessage
  
  ' Did you send the message again?
  If hWnd = PrevhWnd Then
    If PrevMessage = uMsg Then
      If PrevwParam = wParam And PrevlParam = lParam Then
        ReturnMessage = Me.CallPrevWinProc(hWnd, uMsg, wParam, lParam)
        Exit Function
      End If
    End If
  End If
  
  ' Raise the event.
  ReturnMessage = evtCallPrevWinProc ' Set default to avoid mistakes from users of this control.
  RaiseEvent ReceivedMessage(hWnd, uMsg, wParam, lParam, ReturnMessage)
  If ReturnMessage = evtCallPrevWinProc Then ReturnMessage = Me.CallPrevWinProc(hWnd, uMsg, wParam, lParam)
  
  RaiseEventRM = ReturnMessage
End Function


'======================================================
' Class stuff

Public Sub About()
Attribute About.VB_Description = "Shows an about dialog."
Attribute About.VB_UserMemId = -552
Attribute About.VB_MemberFlags = "40"
  frmAbout.Show vbModal
End Sub

Private Sub UserControl_Initialize()
  ME_OBJPTR = ObjPtr(Me)
End Sub

Private Sub UserControl_Resize()
  If Not UserControl.Ambient.UserMode Then
    UserControl.Width = UserControl.ScaleX(UserControl.Picture.Width, vbHimetric, vbTwips)
    UserControl.Height = UserControl.ScaleY(UserControl.Picture.Height, vbHimetric, vbTwips)
  End If
End Sub
